

# Actions


The following actions are supported:
+  [ApplyArchiveRule](API_ApplyArchiveRule.md) 
+  [CancelPolicyGeneration](API_CancelPolicyGeneration.md) 
+  [CheckAccessNotGranted](API_CheckAccessNotGranted.md) 
+  [CheckNoNewAccess](API_CheckNoNewAccess.md) 
+  [CheckNoPublicAccess](API_CheckNoPublicAccess.md) 
+  [CreateAccessPreview](API_CreateAccessPreview.md) 
+  [CreateAnalyzer](API_CreateAnalyzer.md) 
+  [CreateArchiveRule](API_CreateArchiveRule.md) 
+  [DeleteAnalyzer](API_DeleteAnalyzer.md) 
+  [DeleteArchiveRule](API_DeleteArchiveRule.md) 
+  [GenerateFindingRecommendation](API_GenerateFindingRecommendation.md) 
+  [GetAccessPreview](API_GetAccessPreview.md) 
+  [GetAnalyzedResource](API_GetAnalyzedResource.md) 
+  [GetAnalyzer](API_GetAnalyzer.md) 
+  [GetArchiveRule](API_GetArchiveRule.md) 
+  [GetFinding](API_GetFinding.md) 
+  [GetFindingRecommendation](API_GetFindingRecommendation.md) 
+  [GetFindingsStatistics](API_GetFindingsStatistics.md) 
+  [GetFindingV2](API_GetFindingV2.md) 
+  [GetGeneratedPolicy](API_GetGeneratedPolicy.md) 
+  [ListAccessPreviewFindings](API_ListAccessPreviewFindings.md) 
+  [ListAccessPreviews](API_ListAccessPreviews.md) 
+  [ListAnalyzedResources](API_ListAnalyzedResources.md) 
+  [ListAnalyzers](API_ListAnalyzers.md) 
+  [ListArchiveRules](API_ListArchiveRules.md) 
+  [ListFindings](API_ListFindings.md) 
+  [ListFindingsV2](API_ListFindingsV2.md) 
+  [ListPolicyGenerations](API_ListPolicyGenerations.md) 
+  [ListTagsForResource](API_ListTagsForResource.md) 
+  [StartPolicyGeneration](API_StartPolicyGeneration.md) 
+  [StartResourceScan](API_StartResourceScan.md) 
+  [TagResource](API_TagResource.md) 
+  [UntagResource](API_UntagResource.md) 
+  [UpdateAnalyzer](API_UpdateAnalyzer.md) 
+  [UpdateArchiveRule](API_UpdateArchiveRule.md) 
+  [UpdateFindings](API_UpdateFindings.md) 
+  [ValidatePolicy](API_ValidatePolicy.md) 

# ApplyArchiveRule


Retroactively applies the archive rule to existing findings that meet the archive rule criteria.

## Request Syntax


```
PUT /archive-rule HTTP/1.1
Content-type: application/json

{
   "analyzerArn": "string",
   "clientToken": "string",
   "ruleName": "string"
}
```

## URI Request Parameters


The request does not use any URI parameters.

## Request Body


The request accepts the following data in JSON format.

 ** [analyzerArn](#API_ApplyArchiveRule_RequestSyntax) **   <a name="accessanalyzer-ApplyArchiveRule-request-analyzerArn"></a>
The Amazon resource name (ARN) of the analyzer.  
Type: String  
Pattern: `[^:]*:[^:]*:[^:]*:[^:]*:[^:]*:analyzer/.{1,255}`   
Required: Yes

 ** [clientToken](#API_ApplyArchiveRule_RequestSyntax) **   <a name="accessanalyzer-ApplyArchiveRule-request-clientToken"></a>
A client token.  
Type: String  
Required: No

 ** [ruleName](#API_ApplyArchiveRule_RequestSyntax) **   <a name="accessanalyzer-ApplyArchiveRule-request-ruleName"></a>
The name of the rule to apply.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 255.  
Pattern: `[A-Za-z][A-Za-z0-9_.-]*`   
Required: Yes

## Response Syntax


```
HTTP/1.1 200
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response with an empty HTTP body.

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.  
HTTP Status Code: 403

 ** InternalServerException **   
Internal server error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource could not be found.    
 ** resourceId **   
The ID of the resource.  
 ** resourceType **   
The type of the resource.
HTTP Status Code: 404

 ** ThrottlingException **   
Throttling limit exceeded error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 429

 ** ValidationException **   
Validation exception error.    
 ** fieldList **   
A list of fields that didn't validate.  
 ** reason **   
The reason for the exception.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/accessanalyzer-2019-11-01/ApplyArchiveRule) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/accessanalyzer-2019-11-01/ApplyArchiveRule) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/accessanalyzer-2019-11-01/ApplyArchiveRule) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/accessanalyzer-2019-11-01/ApplyArchiveRule) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/accessanalyzer-2019-11-01/ApplyArchiveRule) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/accessanalyzer-2019-11-01/ApplyArchiveRule) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/accessanalyzer-2019-11-01/ApplyArchiveRule) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/accessanalyzer-2019-11-01/ApplyArchiveRule) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/accessanalyzer-2019-11-01/ApplyArchiveRule) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/accessanalyzer-2019-11-01/ApplyArchiveRule) 

# CancelPolicyGeneration


Cancels the requested policy generation.

## Request Syntax


```
PUT /policy/generation/jobId HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [jobId](#API_CancelPolicyGeneration_RequestSyntax) **   <a name="accessanalyzer-CancelPolicyGeneration-request-uri-jobId"></a>
The `JobId` that is returned by the `StartPolicyGeneration` operation. The `JobId` can be used with `GetGeneratedPolicy` to retrieve the generated policies or used with `CancelPolicyGeneration` to cancel the policy generation request.  
Required: Yes

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response with an empty HTTP body.

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.  
HTTP Status Code: 403

 ** InternalServerException **   
Internal server error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 500

 ** ThrottlingException **   
Throttling limit exceeded error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 429

 ** ValidationException **   
Validation exception error.    
 ** fieldList **   
A list of fields that didn't validate.  
 ** reason **   
The reason for the exception.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/accessanalyzer-2019-11-01/CancelPolicyGeneration) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/accessanalyzer-2019-11-01/CancelPolicyGeneration) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/accessanalyzer-2019-11-01/CancelPolicyGeneration) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/accessanalyzer-2019-11-01/CancelPolicyGeneration) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/accessanalyzer-2019-11-01/CancelPolicyGeneration) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/accessanalyzer-2019-11-01/CancelPolicyGeneration) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/accessanalyzer-2019-11-01/CancelPolicyGeneration) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/accessanalyzer-2019-11-01/CancelPolicyGeneration) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/accessanalyzer-2019-11-01/CancelPolicyGeneration) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/accessanalyzer-2019-11-01/CancelPolicyGeneration) 

# CheckAccessNotGranted


Checks whether the specified access isn't allowed by a policy.

## Request Syntax


```
POST /policy/check-access-not-granted HTTP/1.1
Content-type: application/json

{
   "access": [ 
      { 
         "actions": [ "string" ],
         "resources": [ "string" ]
      }
   ],
   "policyDocument": "string",
   "policyType": "string"
}
```

## URI Request Parameters


The request does not use any URI parameters.

## Request Body


The request accepts the following data in JSON format.

 ** [access](#API_CheckAccessNotGranted_RequestSyntax) **   <a name="accessanalyzer-CheckAccessNotGranted-request-access"></a>
An access object containing the permissions that shouldn't be granted by the specified policy. If only actions are specified, IAM Access Analyzer checks for access to peform at least one of the actions on any resource in the policy. If only resources are specified, then IAM Access Analyzer checks for access to perform any action on at least one of the resources. If both actions and resources are specified, IAM Access Analyzer checks for access to perform at least one of the specified actions on at least one of the specified resources.  
Type: Array of [Access](API_Access.md) objects  
Array Members: Minimum number of 0 items. Maximum number of 1 item.  
Required: Yes

 ** [policyDocument](#API_CheckAccessNotGranted_RequestSyntax) **   <a name="accessanalyzer-CheckAccessNotGranted-request-policyDocument"></a>
The JSON policy document to use as the content for the policy.  
Type: String  
Required: Yes

 ** [policyType](#API_CheckAccessNotGranted_RequestSyntax) **   <a name="accessanalyzer-CheckAccessNotGranted-request-policyType"></a>
The type of policy. Identity policies grant permissions to IAM principals. Identity policies include managed and inline policies for IAM roles, users, and groups.  
Resource policies grant permissions on AWS resources. Resource policies include trust policies for IAM roles and bucket policies for Amazon S3 buckets.  
Type: String  
Valid Values: `IDENTITY_POLICY | RESOURCE_POLICY`   
Required: Yes

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "message": "string",
   "reasons": [ 
      { 
         "description": "string",
         "statementId": "string",
         "statementIndex": number
      }
   ],
   "result": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [message](#API_CheckAccessNotGranted_ResponseSyntax) **   <a name="accessanalyzer-CheckAccessNotGranted-response-message"></a>
The message indicating whether the specified access is allowed.  
Type: String

 ** [reasons](#API_CheckAccessNotGranted_ResponseSyntax) **   <a name="accessanalyzer-CheckAccessNotGranted-response-reasons"></a>
A description of the reasoning of the result.  
Type: Array of [ReasonSummary](API_ReasonSummary.md) objects

 ** [result](#API_CheckAccessNotGranted_ResponseSyntax) **   <a name="accessanalyzer-CheckAccessNotGranted-response-result"></a>
The result of the check for whether the access is allowed. If the result is `PASS`, the specified policy doesn't allow any of the specified permissions in the access object. If the result is `FAIL`, the specified policy might allow some or all of the permissions in the access object.  
Type: String  
Valid Values: `PASS | FAIL` 

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.  
HTTP Status Code: 403

 ** InternalServerException **   
Internal server error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 500

 ** InvalidParameterException **   
The specified parameter is invalid.  
HTTP Status Code: 400

 ** ThrottlingException **   
Throttling limit exceeded error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 429

 ** UnprocessableEntityException **   
The specified entity could not be processed.  
HTTP Status Code: 422

 ** ValidationException **   
Validation exception error.    
 ** fieldList **   
A list of fields that didn't validate.  
 ** reason **   
The reason for the exception.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/accessanalyzer-2019-11-01/CheckAccessNotGranted) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/accessanalyzer-2019-11-01/CheckAccessNotGranted) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/accessanalyzer-2019-11-01/CheckAccessNotGranted) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/accessanalyzer-2019-11-01/CheckAccessNotGranted) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/accessanalyzer-2019-11-01/CheckAccessNotGranted) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/accessanalyzer-2019-11-01/CheckAccessNotGranted) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/accessanalyzer-2019-11-01/CheckAccessNotGranted) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/accessanalyzer-2019-11-01/CheckAccessNotGranted) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/accessanalyzer-2019-11-01/CheckAccessNotGranted) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/accessanalyzer-2019-11-01/CheckAccessNotGranted) 

# CheckNoNewAccess


Checks whether new access is allowed for an updated policy when compared to the existing policy.

You can find examples for reference policies and learn how to set up and run a custom policy check for new access in the [IAM Access Analyzer custom policy checks samples](https://github.com/aws-samples/iam-access-analyzer-custom-policy-check-samples) repository on GitHub. The reference policies in this repository are meant to be passed to the `existingPolicyDocument` request parameter.

## Request Syntax


```
POST /policy/check-no-new-access HTTP/1.1
Content-type: application/json

{
   "existingPolicyDocument": "string",
   "newPolicyDocument": "string",
   "policyType": "string"
}
```

## URI Request Parameters


The request does not use any URI parameters.

## Request Body


The request accepts the following data in JSON format.

 ** [existingPolicyDocument](#API_CheckNoNewAccess_RequestSyntax) **   <a name="accessanalyzer-CheckNoNewAccess-request-existingPolicyDocument"></a>
The JSON policy document to use as the content for the existing policy.  
Type: String  
Required: Yes

 ** [newPolicyDocument](#API_CheckNoNewAccess_RequestSyntax) **   <a name="accessanalyzer-CheckNoNewAccess-request-newPolicyDocument"></a>
The JSON policy document to use as the content for the updated policy.  
Type: String  
Required: Yes

 ** [policyType](#API_CheckNoNewAccess_RequestSyntax) **   <a name="accessanalyzer-CheckNoNewAccess-request-policyType"></a>
The type of policy to compare. Identity policies grant permissions to IAM principals. Identity policies include managed and inline policies for IAM roles, users, and groups.  
Resource policies grant permissions on AWS resources. Resource policies include trust policies for IAM roles and bucket policies for Amazon S3 buckets. You can provide a generic input such as identity policy or resource policy or a specific input such as managed policy or Amazon S3 bucket policy.  
Type: String  
Valid Values: `IDENTITY_POLICY | RESOURCE_POLICY`   
Required: Yes

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "message": "string",
   "reasons": [ 
      { 
         "description": "string",
         "statementId": "string",
         "statementIndex": number
      }
   ],
   "result": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [message](#API_CheckNoNewAccess_ResponseSyntax) **   <a name="accessanalyzer-CheckNoNewAccess-response-message"></a>
The message indicating whether the updated policy allows new access.  
Type: String

 ** [reasons](#API_CheckNoNewAccess_ResponseSyntax) **   <a name="accessanalyzer-CheckNoNewAccess-response-reasons"></a>
A description of the reasoning of the result.  
Type: Array of [ReasonSummary](API_ReasonSummary.md) objects

 ** [result](#API_CheckNoNewAccess_ResponseSyntax) **   <a name="accessanalyzer-CheckNoNewAccess-response-result"></a>
The result of the check for new access. If the result is `PASS`, no new access is allowed by the updated policy. If the result is `FAIL`, the updated policy might allow new access.  
Type: String  
Valid Values: `PASS | FAIL` 

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.  
HTTP Status Code: 403

 ** InternalServerException **   
Internal server error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 500

 ** InvalidParameterException **   
The specified parameter is invalid.  
HTTP Status Code: 400

 ** ThrottlingException **   
Throttling limit exceeded error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 429

 ** UnprocessableEntityException **   
The specified entity could not be processed.  
HTTP Status Code: 422

 ** ValidationException **   
Validation exception error.    
 ** fieldList **   
A list of fields that didn't validate.  
 ** reason **   
The reason for the exception.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/accessanalyzer-2019-11-01/CheckNoNewAccess) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/accessanalyzer-2019-11-01/CheckNoNewAccess) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/accessanalyzer-2019-11-01/CheckNoNewAccess) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/accessanalyzer-2019-11-01/CheckNoNewAccess) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/accessanalyzer-2019-11-01/CheckNoNewAccess) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/accessanalyzer-2019-11-01/CheckNoNewAccess) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/accessanalyzer-2019-11-01/CheckNoNewAccess) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/accessanalyzer-2019-11-01/CheckNoNewAccess) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/accessanalyzer-2019-11-01/CheckNoNewAccess) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/accessanalyzer-2019-11-01/CheckNoNewAccess) 

# CheckNoPublicAccess


Checks whether a resource policy can grant public access to the specified resource type.

## Request Syntax


```
POST /policy/check-no-public-access HTTP/1.1
Content-type: application/json

{
   "policyDocument": "string",
   "resourceType": "string"
}
```

## URI Request Parameters


The request does not use any URI parameters.

## Request Body


The request accepts the following data in JSON format.

 ** [policyDocument](#API_CheckNoPublicAccess_RequestSyntax) **   <a name="accessanalyzer-CheckNoPublicAccess-request-policyDocument"></a>
The JSON policy document to evaluate for public access.  
Type: String  
Required: Yes

 ** [resourceType](#API_CheckNoPublicAccess_RequestSyntax) **   <a name="accessanalyzer-CheckNoPublicAccess-request-resourceType"></a>
The type of resource to evaluate for public access. For example, to check for public access to Amazon S3 buckets, you can choose `AWS::S3::Bucket` for the resource type.  
For resource types not supported as valid values, IAM Access Analyzer will return an error.  
Type: String  
Valid Values: `AWS::DynamoDB::Table | AWS::DynamoDB::Stream | AWS::EFS::FileSystem | AWS::OpenSearchService::Domain | AWS::Kinesis::Stream | AWS::Kinesis::StreamConsumer | AWS::KMS::Key | AWS::Lambda::Function | AWS::S3::Bucket | AWS::S3::AccessPoint | AWS::S3Express::DirectoryBucket | AWS::S3::Glacier | AWS::S3Outposts::Bucket | AWS::S3Outposts::AccessPoint | AWS::SecretsManager::Secret | AWS::SNS::Topic | AWS::SQS::Queue | AWS::IAM::AssumeRolePolicyDocument | AWS::S3Tables::TableBucket | AWS::ApiGateway::RestApi | AWS::CodeArtifact::Domain | AWS::Backup::BackupVault | AWS::CloudTrail::Dashboard | AWS::CloudTrail::EventDataStore | AWS::S3Tables::Table | AWS::S3Express::AccessPoint`   
Required: Yes

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "message": "string",
   "reasons": [ 
      { 
         "description": "string",
         "statementId": "string",
         "statementIndex": number
      }
   ],
   "result": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [message](#API_CheckNoPublicAccess_ResponseSyntax) **   <a name="accessanalyzer-CheckNoPublicAccess-response-message"></a>
The message indicating whether the specified policy allows public access to resources.  
Type: String

 ** [reasons](#API_CheckNoPublicAccess_ResponseSyntax) **   <a name="accessanalyzer-CheckNoPublicAccess-response-reasons"></a>
A list of reasons why the specified resource policy grants public access for the resource type.  
Type: Array of [ReasonSummary](API_ReasonSummary.md) objects

 ** [result](#API_CheckNoPublicAccess_ResponseSyntax) **   <a name="accessanalyzer-CheckNoPublicAccess-response-result"></a>
The result of the check for public access to the specified resource type. If the result is `PASS`, the policy doesn't allow public access to the specified resource type. If the result is `FAIL`, the policy might allow public access to the specified resource type.  
Type: String  
Valid Values: `PASS | FAIL` 

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.  
HTTP Status Code: 403

 ** InternalServerException **   
Internal server error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 500

 ** InvalidParameterException **   
The specified parameter is invalid.  
HTTP Status Code: 400

 ** ThrottlingException **   
Throttling limit exceeded error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 429

 ** UnprocessableEntityException **   
The specified entity could not be processed.  
HTTP Status Code: 422

 ** ValidationException **   
Validation exception error.    
 ** fieldList **   
A list of fields that didn't validate.  
 ** reason **   
The reason for the exception.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/accessanalyzer-2019-11-01/CheckNoPublicAccess) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/accessanalyzer-2019-11-01/CheckNoPublicAccess) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/accessanalyzer-2019-11-01/CheckNoPublicAccess) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/accessanalyzer-2019-11-01/CheckNoPublicAccess) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/accessanalyzer-2019-11-01/CheckNoPublicAccess) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/accessanalyzer-2019-11-01/CheckNoPublicAccess) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/accessanalyzer-2019-11-01/CheckNoPublicAccess) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/accessanalyzer-2019-11-01/CheckNoPublicAccess) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/accessanalyzer-2019-11-01/CheckNoPublicAccess) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/accessanalyzer-2019-11-01/CheckNoPublicAccess) 

# CreateAccessPreview


Creates an access preview that allows you to preview IAM Access Analyzer findings for your resource before deploying resource permissions.

## Request Syntax


```
PUT /access-preview HTTP/1.1
Content-type: application/json

{
   "analyzerArn": "string",
   "clientToken": "string",
   "configurations": { 
      "string" : { ... }
   }
}
```

## URI Request Parameters


The request does not use any URI parameters.

## Request Body


The request accepts the following data in JSON format.

 ** [analyzerArn](#API_CreateAccessPreview_RequestSyntax) **   <a name="accessanalyzer-CreateAccessPreview-request-analyzerArn"></a>
The [ARN of the account analyzer](https://docs.aws.amazon.com/IAM/latest/UserGuide/access-analyzer-getting-started.html#permission-resources) used to generate the access preview. You can only create an access preview for analyzers with an `Account` type and `Active` status.  
Type: String  
Pattern: `[^:]*:[^:]*:[^:]*:[^:]*:[^:]*:analyzer/.{1,255}`   
Required: Yes

 ** [clientToken](#API_CreateAccessPreview_RequestSyntax) **   <a name="accessanalyzer-CreateAccessPreview-request-clientToken"></a>
A client token.  
Type: String  
Required: No

 ** [configurations](#API_CreateAccessPreview_RequestSyntax) **   <a name="accessanalyzer-CreateAccessPreview-request-configurations"></a>
Access control configuration for your resource that is used to generate the access preview. The access preview includes findings for external access allowed to the resource with the proposed access control configuration. The configuration must contain exactly one element.  
Type: String to [Configuration](API_Configuration.md) object map  
Required: Yes

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "id": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [id](#API_CreateAccessPreview_ResponseSyntax) **   <a name="accessanalyzer-CreateAccessPreview-response-id"></a>
The unique ID for the access preview.  
Type: String  
Pattern: `[a-f0-9]{8}-[a-f0-9]{4}-[a-f0-9]{4}-[a-f0-9]{4}-[a-f0-9]{12}` 

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.  
HTTP Status Code: 403

 ** ConflictException **   
A conflict exception error.    
 ** resourceId **   
The ID of the resource.  
 ** resourceType **   
The resource type.
HTTP Status Code: 409

 ** InternalServerException **   
Internal server error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource could not be found.    
 ** resourceId **   
The ID of the resource.  
 ** resourceType **   
The type of the resource.
HTTP Status Code: 404

 ** ServiceQuotaExceededException **   
Service quote met error.    
 ** resourceId **   
The resource ID.  
 ** resourceType **   
The resource type.
HTTP Status Code: 402

 ** ThrottlingException **   
Throttling limit exceeded error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 429

 ** ValidationException **   
Validation exception error.    
 ** fieldList **   
A list of fields that didn't validate.  
 ** reason **   
The reason for the exception.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/accessanalyzer-2019-11-01/CreateAccessPreview) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/accessanalyzer-2019-11-01/CreateAccessPreview) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/accessanalyzer-2019-11-01/CreateAccessPreview) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/accessanalyzer-2019-11-01/CreateAccessPreview) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/accessanalyzer-2019-11-01/CreateAccessPreview) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/accessanalyzer-2019-11-01/CreateAccessPreview) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/accessanalyzer-2019-11-01/CreateAccessPreview) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/accessanalyzer-2019-11-01/CreateAccessPreview) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/accessanalyzer-2019-11-01/CreateAccessPreview) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/accessanalyzer-2019-11-01/CreateAccessPreview) 

# CreateAnalyzer


Creates an analyzer for your account.

## Request Syntax


```
PUT /analyzer HTTP/1.1
Content-type: application/json

{
   "analyzerName": "string",
   "archiveRules": [ 
      { 
         "filter": { 
            "string" : { 
               "contains": [ "string" ],
               "eq": [ "string" ],
               "exists": boolean,
               "neq": [ "string" ]
            }
         },
         "ruleName": "string"
      }
   ],
   "clientToken": "string",
   "configuration": { ... },
   "tags": { 
      "string" : "string" 
   },
   "type": "string"
}
```

## URI Request Parameters


The request does not use any URI parameters.

## Request Body


The request accepts the following data in JSON format.

 ** [analyzerName](#API_CreateAnalyzer_RequestSyntax) **   <a name="accessanalyzer-CreateAnalyzer-request-analyzerName"></a>
The name of the analyzer to create.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 255.  
Pattern: `[A-Za-z][A-Za-z0-9_.-]*`   
Required: Yes

 ** [archiveRules](#API_CreateAnalyzer_RequestSyntax) **   <a name="accessanalyzer-CreateAnalyzer-request-archiveRules"></a>
Specifies the archive rules to add for the analyzer. Archive rules automatically archive findings that meet the criteria you define for the rule.  
Type: Array of [InlineArchiveRule](API_InlineArchiveRule.md) objects  
Required: No

 ** [clientToken](#API_CreateAnalyzer_RequestSyntax) **   <a name="accessanalyzer-CreateAnalyzer-request-clientToken"></a>
A client token.  
Type: String  
Required: No

 ** [configuration](#API_CreateAnalyzer_RequestSyntax) **   <a name="accessanalyzer-CreateAnalyzer-request-configuration"></a>
Specifies the configuration of the analyzer. If the analyzer is an unused access analyzer, the specified scope of unused access is used for the configuration. If the analyzer is an internal access analyzer, the specified internal access analysis rules are used for the configuration.  
Type: [AnalyzerConfiguration](API_AnalyzerConfiguration.md) object  
 **Note: **This object is a Union. Only one member of this object can be specified or returned.  
Required: No

 ** [tags](#API_CreateAnalyzer_RequestSyntax) **   <a name="accessanalyzer-CreateAnalyzer-request-tags"></a>
An array of key-value pairs to apply to the analyzer. You can use the set of Unicode letters, digits, whitespace, `_`, `.`, `/`, `=`, `+`, and `-`.  
For the tag key, you can specify a value that is 1 to 128 characters in length and cannot be prefixed with `aws:`.  
For the tag value, you can specify a value that is 0 to 256 characters in length.  
Type: String to string map  
Required: No

 ** [type](#API_CreateAnalyzer_RequestSyntax) **   <a name="accessanalyzer-CreateAnalyzer-request-type"></a>
The type of analyzer to create. You can create only one analyzer per account per Region. You can create up to 5 analyzers per organization per Region.  
Type: String  
Valid Values: `ACCOUNT | ORGANIZATION | ACCOUNT_UNUSED_ACCESS | ORGANIZATION_UNUSED_ACCESS | ACCOUNT_INTERNAL_ACCESS | ORGANIZATION_INTERNAL_ACCESS`   
Required: Yes

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "arn": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [arn](#API_CreateAnalyzer_ResponseSyntax) **   <a name="accessanalyzer-CreateAnalyzer-response-arn"></a>
The ARN of the analyzer that was created by the request.  
Type: String  
Pattern: `[^:]*:[^:]*:[^:]*:[^:]*:[^:]*:analyzer/.{1,255}` 

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.  
HTTP Status Code: 403

 ** ConflictException **   
A conflict exception error.    
 ** resourceId **   
The ID of the resource.  
 ** resourceType **   
The resource type.
HTTP Status Code: 409

 ** InternalServerException **   
Internal server error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 500

 ** ServiceQuotaExceededException **   
Service quote met error.    
 ** resourceId **   
The resource ID.  
 ** resourceType **   
The resource type.
HTTP Status Code: 402

 ** ThrottlingException **   
Throttling limit exceeded error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 429

 ** ValidationException **   
Validation exception error.    
 ** fieldList **   
A list of fields that didn't validate.  
 ** reason **   
The reason for the exception.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/accessanalyzer-2019-11-01/CreateAnalyzer) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/accessanalyzer-2019-11-01/CreateAnalyzer) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/accessanalyzer-2019-11-01/CreateAnalyzer) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/accessanalyzer-2019-11-01/CreateAnalyzer) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/accessanalyzer-2019-11-01/CreateAnalyzer) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/accessanalyzer-2019-11-01/CreateAnalyzer) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/accessanalyzer-2019-11-01/CreateAnalyzer) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/accessanalyzer-2019-11-01/CreateAnalyzer) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/accessanalyzer-2019-11-01/CreateAnalyzer) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/accessanalyzer-2019-11-01/CreateAnalyzer) 

# CreateArchiveRule


Creates an archive rule for the specified analyzer. Archive rules automatically archive new findings that meet the criteria you define when you create the rule.

To learn about filter keys that you can use to create an archive rule, see [IAM Access Analyzer filter keys](https://docs.aws.amazon.com/IAM/latest/UserGuide/access-analyzer-reference-filter-keys.html) in the **IAM User Guide**.

## Request Syntax


```
PUT /analyzer/analyzerName/archive-rule HTTP/1.1
Content-type: application/json

{
   "clientToken": "string",
   "filter": { 
      "string" : { 
         "contains": [ "string" ],
         "eq": [ "string" ],
         "exists": boolean,
         "neq": [ "string" ]
      }
   },
   "ruleName": "string"
}
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [analyzerName](#API_CreateArchiveRule_RequestSyntax) **   <a name="accessanalyzer-CreateArchiveRule-request-uri-analyzerName"></a>
The name of the created analyzer.  
Length Constraints: Minimum length of 1. Maximum length of 255.  
Pattern: `[A-Za-z][A-Za-z0-9_.-]*`   
Required: Yes

## Request Body


The request accepts the following data in JSON format.

 ** [clientToken](#API_CreateArchiveRule_RequestSyntax) **   <a name="accessanalyzer-CreateArchiveRule-request-clientToken"></a>
A client token.  
Type: String  
Required: No

 ** [filter](#API_CreateArchiveRule_RequestSyntax) **   <a name="accessanalyzer-CreateArchiveRule-request-filter"></a>
The criteria for the rule.  
Type: String to [Criterion](API_Criterion.md) object map  
Required: Yes

 ** [ruleName](#API_CreateArchiveRule_RequestSyntax) **   <a name="accessanalyzer-CreateArchiveRule-request-ruleName"></a>
The name of the rule to create.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 255.  
Pattern: `[A-Za-z][A-Za-z0-9_.-]*`   
Required: Yes

## Response Syntax


```
HTTP/1.1 200
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response with an empty HTTP body.

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.  
HTTP Status Code: 403

 ** ConflictException **   
A conflict exception error.    
 ** resourceId **   
The ID of the resource.  
 ** resourceType **   
The resource type.
HTTP Status Code: 409

 ** InternalServerException **   
Internal server error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource could not be found.    
 ** resourceId **   
The ID of the resource.  
 ** resourceType **   
The type of the resource.
HTTP Status Code: 404

 ** ServiceQuotaExceededException **   
Service quote met error.    
 ** resourceId **   
The resource ID.  
 ** resourceType **   
The resource type.
HTTP Status Code: 402

 ** ThrottlingException **   
Throttling limit exceeded error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 429

 ** ValidationException **   
Validation exception error.    
 ** fieldList **   
A list of fields that didn't validate.  
 ** reason **   
The reason for the exception.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/accessanalyzer-2019-11-01/CreateArchiveRule) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/accessanalyzer-2019-11-01/CreateArchiveRule) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/accessanalyzer-2019-11-01/CreateArchiveRule) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/accessanalyzer-2019-11-01/CreateArchiveRule) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/accessanalyzer-2019-11-01/CreateArchiveRule) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/accessanalyzer-2019-11-01/CreateArchiveRule) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/accessanalyzer-2019-11-01/CreateArchiveRule) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/accessanalyzer-2019-11-01/CreateArchiveRule) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/accessanalyzer-2019-11-01/CreateArchiveRule) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/accessanalyzer-2019-11-01/CreateArchiveRule) 

# DeleteAnalyzer


Deletes the specified analyzer. When you delete an analyzer, IAM Access Analyzer is disabled for the account or organization in the current or specific Region. All findings that were generated by the analyzer are deleted. You cannot undo this action.

## Request Syntax


```
DELETE /analyzer/analyzerName?clientToken=clientToken HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [analyzerName](#API_DeleteAnalyzer_RequestSyntax) **   <a name="accessanalyzer-DeleteAnalyzer-request-uri-analyzerName"></a>
The name of the analyzer to delete.  
Length Constraints: Minimum length of 1. Maximum length of 255.  
Pattern: `[A-Za-z][A-Za-z0-9_.-]*`   
Required: Yes

 ** [clientToken](#API_DeleteAnalyzer_RequestSyntax) **   <a name="accessanalyzer-DeleteAnalyzer-request-uri-clientToken"></a>
A client token.

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response with an empty HTTP body.

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.  
HTTP Status Code: 403

 ** InternalServerException **   
Internal server error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource could not be found.    
 ** resourceId **   
The ID of the resource.  
 ** resourceType **   
The type of the resource.
HTTP Status Code: 404

 ** ThrottlingException **   
Throttling limit exceeded error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 429

 ** ValidationException **   
Validation exception error.    
 ** fieldList **   
A list of fields that didn't validate.  
 ** reason **   
The reason for the exception.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/accessanalyzer-2019-11-01/DeleteAnalyzer) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/accessanalyzer-2019-11-01/DeleteAnalyzer) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/accessanalyzer-2019-11-01/DeleteAnalyzer) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/accessanalyzer-2019-11-01/DeleteAnalyzer) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/accessanalyzer-2019-11-01/DeleteAnalyzer) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/accessanalyzer-2019-11-01/DeleteAnalyzer) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/accessanalyzer-2019-11-01/DeleteAnalyzer) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/accessanalyzer-2019-11-01/DeleteAnalyzer) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/accessanalyzer-2019-11-01/DeleteAnalyzer) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/accessanalyzer-2019-11-01/DeleteAnalyzer) 

# DeleteArchiveRule


Deletes the specified archive rule.

## Request Syntax


```
DELETE /analyzer/analyzerName/archive-rule/ruleName?clientToken=clientToken HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [analyzerName](#API_DeleteArchiveRule_RequestSyntax) **   <a name="accessanalyzer-DeleteArchiveRule-request-uri-analyzerName"></a>
The name of the analyzer that associated with the archive rule to delete.  
Length Constraints: Minimum length of 1. Maximum length of 255.  
Pattern: `[A-Za-z][A-Za-z0-9_.-]*`   
Required: Yes

 ** [clientToken](#API_DeleteArchiveRule_RequestSyntax) **   <a name="accessanalyzer-DeleteArchiveRule-request-uri-clientToken"></a>
A client token.

 ** [ruleName](#API_DeleteArchiveRule_RequestSyntax) **   <a name="accessanalyzer-DeleteArchiveRule-request-uri-ruleName"></a>
The name of the rule to delete.  
Length Constraints: Minimum length of 1. Maximum length of 255.  
Pattern: `[A-Za-z][A-Za-z0-9_.-]*`   
Required: Yes

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response with an empty HTTP body.

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.  
HTTP Status Code: 403

 ** InternalServerException **   
Internal server error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource could not be found.    
 ** resourceId **   
The ID of the resource.  
 ** resourceType **   
The type of the resource.
HTTP Status Code: 404

 ** ThrottlingException **   
Throttling limit exceeded error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 429

 ** ValidationException **   
Validation exception error.    
 ** fieldList **   
A list of fields that didn't validate.  
 ** reason **   
The reason for the exception.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/accessanalyzer-2019-11-01/DeleteArchiveRule) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/accessanalyzer-2019-11-01/DeleteArchiveRule) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/accessanalyzer-2019-11-01/DeleteArchiveRule) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/accessanalyzer-2019-11-01/DeleteArchiveRule) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/accessanalyzer-2019-11-01/DeleteArchiveRule) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/accessanalyzer-2019-11-01/DeleteArchiveRule) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/accessanalyzer-2019-11-01/DeleteArchiveRule) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/accessanalyzer-2019-11-01/DeleteArchiveRule) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/accessanalyzer-2019-11-01/DeleteArchiveRule) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/accessanalyzer-2019-11-01/DeleteArchiveRule) 

# GenerateFindingRecommendation


Creates a recommendation for an unused permissions finding.

## Request Syntax


```
POST /recommendation/id?analyzerArn=analyzerArn HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [analyzerArn](#API_GenerateFindingRecommendation_RequestSyntax) **   <a name="accessanalyzer-GenerateFindingRecommendation-request-uri-analyzerArn"></a>
The [ARN of the analyzer](https://docs.aws.amazon.com/IAM/latest/UserGuide/access-analyzer-getting-started.html#permission-resources) used to generate the finding recommendation.  
Pattern: `[^:]*:[^:]*:[^:]*:[^:]*:[^:]*:analyzer/.{1,255}`   
Required: Yes

 ** [id](#API_GenerateFindingRecommendation_RequestSyntax) **   <a name="accessanalyzer-GenerateFindingRecommendation-request-uri-id"></a>
The unique ID for the finding recommendation.  
Length Constraints: Minimum length of 1. Maximum length of 2048.  
Required: Yes

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response with an empty HTTP body.

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.  
HTTP Status Code: 403

 ** InternalServerException **   
Internal server error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 500

 ** ThrottlingException **   
Throttling limit exceeded error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 429

 ** ValidationException **   
Validation exception error.    
 ** fieldList **   
A list of fields that didn't validate.  
 ** reason **   
The reason for the exception.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/accessanalyzer-2019-11-01/GenerateFindingRecommendation) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/accessanalyzer-2019-11-01/GenerateFindingRecommendation) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/accessanalyzer-2019-11-01/GenerateFindingRecommendation) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/accessanalyzer-2019-11-01/GenerateFindingRecommendation) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/accessanalyzer-2019-11-01/GenerateFindingRecommendation) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/accessanalyzer-2019-11-01/GenerateFindingRecommendation) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/accessanalyzer-2019-11-01/GenerateFindingRecommendation) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/accessanalyzer-2019-11-01/GenerateFindingRecommendation) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/accessanalyzer-2019-11-01/GenerateFindingRecommendation) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/accessanalyzer-2019-11-01/GenerateFindingRecommendation) 

# GetAccessPreview


Retrieves information about an access preview for the specified analyzer.

## Request Syntax


```
GET /access-preview/accessPreviewId?analyzerArn=analyzerArn HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [accessPreviewId](#API_GetAccessPreview_RequestSyntax) **   <a name="accessanalyzer-GetAccessPreview-request-uri-accessPreviewId"></a>
The unique ID for the access preview.  
Pattern: `[a-f0-9]{8}-[a-f0-9]{4}-[a-f0-9]{4}-[a-f0-9]{4}-[a-f0-9]{12}`   
Required: Yes

 ** [analyzerArn](#API_GetAccessPreview_RequestSyntax) **   <a name="accessanalyzer-GetAccessPreview-request-uri-analyzerArn"></a>
The [ARN of the analyzer](https://docs.aws.amazon.com/IAM/latest/UserGuide/access-analyzer-getting-started.html#permission-resources) used to generate the access preview.  
Pattern: `[^:]*:[^:]*:[^:]*:[^:]*:[^:]*:analyzer/.{1,255}`   
Required: Yes

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "accessPreview": { 
      "analyzerArn": "string",
      "configurations": { 
         "string" : { ... }
      },
      "createdAt": "string",
      "id": "string",
      "status": "string",
      "statusReason": { 
         "code": "string"
      }
   }
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [accessPreview](#API_GetAccessPreview_ResponseSyntax) **   <a name="accessanalyzer-GetAccessPreview-response-accessPreview"></a>
An object that contains information about the access preview.  
Type: [AccessPreview](API_AccessPreview.md) object

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.  
HTTP Status Code: 403

 ** InternalServerException **   
Internal server error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource could not be found.    
 ** resourceId **   
The ID of the resource.  
 ** resourceType **   
The type of the resource.
HTTP Status Code: 404

 ** ThrottlingException **   
Throttling limit exceeded error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 429

 ** ValidationException **   
Validation exception error.    
 ** fieldList **   
A list of fields that didn't validate.  
 ** reason **   
The reason for the exception.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/accessanalyzer-2019-11-01/GetAccessPreview) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/accessanalyzer-2019-11-01/GetAccessPreview) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/accessanalyzer-2019-11-01/GetAccessPreview) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/accessanalyzer-2019-11-01/GetAccessPreview) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/accessanalyzer-2019-11-01/GetAccessPreview) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/accessanalyzer-2019-11-01/GetAccessPreview) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/accessanalyzer-2019-11-01/GetAccessPreview) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/accessanalyzer-2019-11-01/GetAccessPreview) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/accessanalyzer-2019-11-01/GetAccessPreview) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/accessanalyzer-2019-11-01/GetAccessPreview) 

# GetAnalyzedResource


Retrieves information about a resource that was analyzed.

**Note**  
This action is supported only for external access analyzers.

## Request Syntax


```
GET /analyzed-resource?analyzerArn=analyzerArn&resourceArn=resourceArn HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [analyzerArn](#API_GetAnalyzedResource_RequestSyntax) **   <a name="accessanalyzer-GetAnalyzedResource-request-uri-analyzerArn"></a>
The [ARN of the analyzer](https://docs.aws.amazon.com/IAM/latest/UserGuide/access-analyzer-getting-started.html#permission-resources) to retrieve information from.  
Pattern: `[^:]*:[^:]*:[^:]*:[^:]*:[^:]*:analyzer/.{1,255}`   
Required: Yes

 ** [resourceArn](#API_GetAnalyzedResource_RequestSyntax) **   <a name="accessanalyzer-GetAnalyzedResource-request-uri-resourceArn"></a>
The ARN of the resource to retrieve information about.  
Pattern: `arn:[^:]*:[^:]*:[^:]*:[^:]*:.*`   
Required: Yes

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "resource": { 
      "actions": [ "string" ],
      "analyzedAt": "string",
      "createdAt": "string",
      "error": "string",
      "isPublic": boolean,
      "resourceArn": "string",
      "resourceOwnerAccount": "string",
      "resourceType": "string",
      "sharedVia": [ "string" ],
      "status": "string",
      "updatedAt": "string"
   }
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [resource](#API_GetAnalyzedResource_ResponseSyntax) **   <a name="accessanalyzer-GetAnalyzedResource-response-resource"></a>
An `AnalyzedResource` object that contains information that IAM Access Analyzer found when it analyzed the resource.  
Type: [AnalyzedResource](API_AnalyzedResource.md) object

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.  
HTTP Status Code: 403

 ** InternalServerException **   
Internal server error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource could not be found.    
 ** resourceId **   
The ID of the resource.  
 ** resourceType **   
The type of the resource.
HTTP Status Code: 404

 ** ThrottlingException **   
Throttling limit exceeded error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 429

 ** ValidationException **   
Validation exception error.    
 ** fieldList **   
A list of fields that didn't validate.  
 ** reason **   
The reason for the exception.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/accessanalyzer-2019-11-01/GetAnalyzedResource) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/accessanalyzer-2019-11-01/GetAnalyzedResource) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/accessanalyzer-2019-11-01/GetAnalyzedResource) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/accessanalyzer-2019-11-01/GetAnalyzedResource) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/accessanalyzer-2019-11-01/GetAnalyzedResource) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/accessanalyzer-2019-11-01/GetAnalyzedResource) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/accessanalyzer-2019-11-01/GetAnalyzedResource) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/accessanalyzer-2019-11-01/GetAnalyzedResource) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/accessanalyzer-2019-11-01/GetAnalyzedResource) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/accessanalyzer-2019-11-01/GetAnalyzedResource) 

# GetAnalyzer


Retrieves information about the specified analyzer.

## Request Syntax


```
GET /analyzer/analyzerName HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [analyzerName](#API_GetAnalyzer_RequestSyntax) **   <a name="accessanalyzer-GetAnalyzer-request-uri-analyzerName"></a>
The name of the analyzer retrieved.  
Length Constraints: Minimum length of 1. Maximum length of 255.  
Pattern: `[A-Za-z][A-Za-z0-9_.-]*`   
Required: Yes

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "analyzer": { 
      "arn": "string",
      "configuration": { ... },
      "createdAt": "string",
      "lastResourceAnalyzed": "string",
      "lastResourceAnalyzedAt": "string",
      "name": "string",
      "status": "string",
      "statusReason": { 
         "code": "string"
      },
      "tags": { 
         "string" : "string" 
      },
      "type": "string"
   }
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [analyzer](#API_GetAnalyzer_ResponseSyntax) **   <a name="accessanalyzer-GetAnalyzer-response-analyzer"></a>
An `AnalyzerSummary` object that contains information about the analyzer.  
Type: [AnalyzerSummary](API_AnalyzerSummary.md) object

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.  
HTTP Status Code: 403

 ** InternalServerException **   
Internal server error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource could not be found.    
 ** resourceId **   
The ID of the resource.  
 ** resourceType **   
The type of the resource.
HTTP Status Code: 404

 ** ThrottlingException **   
Throttling limit exceeded error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 429

 ** ValidationException **   
Validation exception error.    
 ** fieldList **   
A list of fields that didn't validate.  
 ** reason **   
The reason for the exception.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/accessanalyzer-2019-11-01/GetAnalyzer) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/accessanalyzer-2019-11-01/GetAnalyzer) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/accessanalyzer-2019-11-01/GetAnalyzer) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/accessanalyzer-2019-11-01/GetAnalyzer) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/accessanalyzer-2019-11-01/GetAnalyzer) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/accessanalyzer-2019-11-01/GetAnalyzer) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/accessanalyzer-2019-11-01/GetAnalyzer) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/accessanalyzer-2019-11-01/GetAnalyzer) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/accessanalyzer-2019-11-01/GetAnalyzer) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/accessanalyzer-2019-11-01/GetAnalyzer) 

# GetArchiveRule


Retrieves information about an archive rule.

To learn about filter keys that you can use to create an archive rule, see [IAM Access Analyzer filter keys](https://docs.aws.amazon.com/IAM/latest/UserGuide/access-analyzer-reference-filter-keys.html) in the **IAM User Guide**.

## Request Syntax


```
GET /analyzer/analyzerName/archive-rule/ruleName HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [analyzerName](#API_GetArchiveRule_RequestSyntax) **   <a name="accessanalyzer-GetArchiveRule-request-uri-analyzerName"></a>
The name of the analyzer to retrieve rules from.  
Length Constraints: Minimum length of 1. Maximum length of 255.  
Pattern: `[A-Za-z][A-Za-z0-9_.-]*`   
Required: Yes

 ** [ruleName](#API_GetArchiveRule_RequestSyntax) **   <a name="accessanalyzer-GetArchiveRule-request-uri-ruleName"></a>
The name of the rule to retrieve.  
Length Constraints: Minimum length of 1. Maximum length of 255.  
Pattern: `[A-Za-z][A-Za-z0-9_.-]*`   
Required: Yes

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "archiveRule": { 
      "createdAt": "string",
      "filter": { 
         "string" : { 
            "contains": [ "string" ],
            "eq": [ "string" ],
            "exists": boolean,
            "neq": [ "string" ]
         }
      },
      "ruleName": "string",
      "updatedAt": "string"
   }
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [archiveRule](#API_GetArchiveRule_ResponseSyntax) **   <a name="accessanalyzer-GetArchiveRule-response-archiveRule"></a>
Contains information about an archive rule. Archive rules automatically archive new findings that meet the criteria you define when you create the rule.  
Type: [ArchiveRuleSummary](API_ArchiveRuleSummary.md) object

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.  
HTTP Status Code: 403

 ** InternalServerException **   
Internal server error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource could not be found.    
 ** resourceId **   
The ID of the resource.  
 ** resourceType **   
The type of the resource.
HTTP Status Code: 404

 ** ThrottlingException **   
Throttling limit exceeded error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 429

 ** ValidationException **   
Validation exception error.    
 ** fieldList **   
A list of fields that didn't validate.  
 ** reason **   
The reason for the exception.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/accessanalyzer-2019-11-01/GetArchiveRule) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/accessanalyzer-2019-11-01/GetArchiveRule) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/accessanalyzer-2019-11-01/GetArchiveRule) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/accessanalyzer-2019-11-01/GetArchiveRule) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/accessanalyzer-2019-11-01/GetArchiveRule) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/accessanalyzer-2019-11-01/GetArchiveRule) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/accessanalyzer-2019-11-01/GetArchiveRule) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/accessanalyzer-2019-11-01/GetArchiveRule) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/accessanalyzer-2019-11-01/GetArchiveRule) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/accessanalyzer-2019-11-01/GetArchiveRule) 

# GetFinding


Retrieves information about the specified finding. GetFinding and GetFindingV2 both use `access-analyzer:GetFinding` in the `Action` element of an IAM policy statement. You must have permission to perform the `access-analyzer:GetFinding` action.

**Note**  
GetFinding is supported only for external access analyzers. You must use GetFindingV2 for internal and unused access analyzers.

## Request Syntax


```
GET /finding/id?analyzerArn=analyzerArn HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [analyzerArn](#API_GetFinding_RequestSyntax) **   <a name="accessanalyzer-GetFinding-request-uri-analyzerArn"></a>
The [ARN of the analyzer](https://docs.aws.amazon.com/IAM/latest/UserGuide/access-analyzer-getting-started.html#permission-resources) that generated the finding.  
Pattern: `[^:]*:[^:]*:[^:]*:[^:]*:[^:]*:analyzer/.{1,255}`   
Required: Yes

 ** [id](#API_GetFinding_RequestSyntax) **   <a name="accessanalyzer-GetFinding-request-uri-id"></a>
The ID of the finding to retrieve.  
Required: Yes

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "finding": { 
      "action": [ "string" ],
      "analyzedAt": "string",
      "condition": { 
         "string" : "string" 
      },
      "createdAt": "string",
      "error": "string",
      "id": "string",
      "isPublic": boolean,
      "principal": { 
         "string" : "string" 
      },
      "resource": "string",
      "resourceControlPolicyRestriction": "string",
      "resourceOwnerAccount": "string",
      "resourceType": "string",
      "sources": [ 
         { 
            "detail": { 
               "accessPointAccount": "string",
               "accessPointArn": "string"
            },
            "type": "string"
         }
      ],
      "status": "string",
      "updatedAt": "string"
   }
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [finding](#API_GetFinding_ResponseSyntax) **   <a name="accessanalyzer-GetFinding-response-finding"></a>
A `finding` object that contains finding details.  
Type: [Finding](API_Finding.md) object

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.  
HTTP Status Code: 403

 ** InternalServerException **   
Internal server error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource could not be found.    
 ** resourceId **   
The ID of the resource.  
 ** resourceType **   
The type of the resource.
HTTP Status Code: 404

 ** ThrottlingException **   
Throttling limit exceeded error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 429

 ** ValidationException **   
Validation exception error.    
 ** fieldList **   
A list of fields that didn't validate.  
 ** reason **   
The reason for the exception.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/accessanalyzer-2019-11-01/GetFinding) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/accessanalyzer-2019-11-01/GetFinding) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/accessanalyzer-2019-11-01/GetFinding) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/accessanalyzer-2019-11-01/GetFinding) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/accessanalyzer-2019-11-01/GetFinding) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/accessanalyzer-2019-11-01/GetFinding) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/accessanalyzer-2019-11-01/GetFinding) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/accessanalyzer-2019-11-01/GetFinding) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/accessanalyzer-2019-11-01/GetFinding) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/accessanalyzer-2019-11-01/GetFinding) 

# GetFindingRecommendation


Retrieves information about a finding recommendation for the specified analyzer.

## Request Syntax


```
GET /recommendation/id?analyzerArn=analyzerArn&maxResults=maxResults&nextToken=nextToken HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [analyzerArn](#API_GetFindingRecommendation_RequestSyntax) **   <a name="accessanalyzer-GetFindingRecommendation-request-uri-analyzerArn"></a>
The [ARN of the analyzer](https://docs.aws.amazon.com/IAM/latest/UserGuide/access-analyzer-getting-started.html#permission-resources) used to generate the finding recommendation.  
Pattern: `[^:]*:[^:]*:[^:]*:[^:]*:[^:]*:analyzer/.{1,255}`   
Required: Yes

 ** [id](#API_GetFindingRecommendation_RequestSyntax) **   <a name="accessanalyzer-GetFindingRecommendation-request-uri-id"></a>
The unique ID for the finding recommendation.  
Length Constraints: Minimum length of 1. Maximum length of 2048.  
Required: Yes

 ** [maxResults](#API_GetFindingRecommendation_RequestSyntax) **   <a name="accessanalyzer-GetFindingRecommendation-request-uri-maxResults"></a>
The maximum number of results to return in the response.  
Valid Range: Minimum value of 1. Maximum value of 1000.

 ** [nextToken](#API_GetFindingRecommendation_RequestSyntax) **   <a name="accessanalyzer-GetFindingRecommendation-request-uri-nextToken"></a>
A token used for pagination of results returned.

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "completedAt": "string",
   "error": { 
      "code": "string",
      "message": "string"
   },
   "nextToken": "string",
   "recommendationType": "string",
   "recommendedSteps": [ 
      { ... }
   ],
   "resourceArn": "string",
   "startedAt": "string",
   "status": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [completedAt](#API_GetFindingRecommendation_ResponseSyntax) **   <a name="accessanalyzer-GetFindingRecommendation-response-completedAt"></a>
The time at which the retrieval of the finding recommendation was completed.  
Type: Timestamp

 ** [error](#API_GetFindingRecommendation_ResponseSyntax) **   <a name="accessanalyzer-GetFindingRecommendation-response-error"></a>
Detailed information about the reason that the retrieval of a recommendation for the finding failed.  
Type: [RecommendationError](API_RecommendationError.md) object

 ** [nextToken](#API_GetFindingRecommendation_ResponseSyntax) **   <a name="accessanalyzer-GetFindingRecommendation-response-nextToken"></a>
A token used for pagination of results returned.  
Type: String

 ** [recommendationType](#API_GetFindingRecommendation_ResponseSyntax) **   <a name="accessanalyzer-GetFindingRecommendation-response-recommendationType"></a>
The type of recommendation for the finding.  
Type: String  
Valid Values: `UnusedPermissionRecommendation` 

 ** [recommendedSteps](#API_GetFindingRecommendation_ResponseSyntax) **   <a name="accessanalyzer-GetFindingRecommendation-response-recommendedSteps"></a>
A group of recommended steps for the finding.  
Type: Array of [RecommendedStep](API_RecommendedStep.md) objects

 ** [resourceArn](#API_GetFindingRecommendation_ResponseSyntax) **   <a name="accessanalyzer-GetFindingRecommendation-response-resourceArn"></a>
The ARN of the resource of the finding.  
Type: String  
Pattern: `arn:[^:]*:[^:]*:[^:]*:[^:]*:.*` 

 ** [startedAt](#API_GetFindingRecommendation_ResponseSyntax) **   <a name="accessanalyzer-GetFindingRecommendation-response-startedAt"></a>
The time at which the retrieval of the finding recommendation was started.  
Type: Timestamp

 ** [status](#API_GetFindingRecommendation_ResponseSyntax) **   <a name="accessanalyzer-GetFindingRecommendation-response-status"></a>
The status of the retrieval of the finding recommendation.  
Type: String  
Valid Values: `SUCCEEDED | FAILED | IN_PROGRESS` 

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.  
HTTP Status Code: 403

 ** InternalServerException **   
Internal server error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource could not be found.    
 ** resourceId **   
The ID of the resource.  
 ** resourceType **   
The type of the resource.
HTTP Status Code: 404

 ** ThrottlingException **   
Throttling limit exceeded error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 429

 ** ValidationException **   
Validation exception error.    
 ** fieldList **   
A list of fields that didn't validate.  
 ** reason **   
The reason for the exception.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/accessanalyzer-2019-11-01/GetFindingRecommendation) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/accessanalyzer-2019-11-01/GetFindingRecommendation) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/accessanalyzer-2019-11-01/GetFindingRecommendation) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/accessanalyzer-2019-11-01/GetFindingRecommendation) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/accessanalyzer-2019-11-01/GetFindingRecommendation) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/accessanalyzer-2019-11-01/GetFindingRecommendation) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/accessanalyzer-2019-11-01/GetFindingRecommendation) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/accessanalyzer-2019-11-01/GetFindingRecommendation) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/accessanalyzer-2019-11-01/GetFindingRecommendation) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/accessanalyzer-2019-11-01/GetFindingRecommendation) 

# GetFindingsStatistics


Retrieves a list of aggregated finding statistics for an external access or unused access analyzer.

## Request Syntax


```
POST /analyzer/findings/statistics HTTP/1.1
Content-type: application/json

{
   "analyzerArn": "string"
}
```

## URI Request Parameters


The request does not use any URI parameters.

## Request Body


The request accepts the following data in JSON format.

 ** [analyzerArn](#API_GetFindingsStatistics_RequestSyntax) **   <a name="accessanalyzer-GetFindingsStatistics-request-analyzerArn"></a>
The [ARN of the analyzer](https://docs.aws.amazon.com/IAM/latest/UserGuide/access-analyzer-getting-started.html#permission-resources) used to generate the statistics.  
Type: String  
Pattern: `[^:]*:[^:]*:[^:]*:[^:]*:[^:]*:analyzer/.{1,255}`   
Required: Yes

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "findingsStatistics": [ 
      { ... }
   ],
   "lastUpdatedAt": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [findingsStatistics](#API_GetFindingsStatistics_ResponseSyntax) **   <a name="accessanalyzer-GetFindingsStatistics-response-findingsStatistics"></a>
A group of external access or unused access findings statistics.  
Type: Array of [FindingsStatistics](API_FindingsStatistics.md) objects

 ** [lastUpdatedAt](#API_GetFindingsStatistics_ResponseSyntax) **   <a name="accessanalyzer-GetFindingsStatistics-response-lastUpdatedAt"></a>
The time at which the retrieval of the findings statistics was last updated. If the findings statistics have not been previously retrieved for the specified analyzer, this field will not be populated.  
Type: Timestamp

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.  
HTTP Status Code: 403

 ** InternalServerException **   
Internal server error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource could not be found.    
 ** resourceId **   
The ID of the resource.  
 ** resourceType **   
The type of the resource.
HTTP Status Code: 404

 ** ThrottlingException **   
Throttling limit exceeded error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 429

 ** ValidationException **   
Validation exception error.    
 ** fieldList **   
A list of fields that didn't validate.  
 ** reason **   
The reason for the exception.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/accessanalyzer-2019-11-01/GetFindingsStatistics) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/accessanalyzer-2019-11-01/GetFindingsStatistics) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/accessanalyzer-2019-11-01/GetFindingsStatistics) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/accessanalyzer-2019-11-01/GetFindingsStatistics) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/accessanalyzer-2019-11-01/GetFindingsStatistics) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/accessanalyzer-2019-11-01/GetFindingsStatistics) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/accessanalyzer-2019-11-01/GetFindingsStatistics) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/accessanalyzer-2019-11-01/GetFindingsStatistics) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/accessanalyzer-2019-11-01/GetFindingsStatistics) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/accessanalyzer-2019-11-01/GetFindingsStatistics) 

# GetFindingV2


Retrieves information about the specified finding. GetFinding and GetFindingV2 both use `access-analyzer:GetFinding` in the `Action` element of an IAM policy statement. You must have permission to perform the `access-analyzer:GetFinding` action.

## Request Syntax


```
GET /findingv2/id?analyzerArn=analyzerArn&maxResults=maxResults&nextToken=nextToken HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [analyzerArn](#API_GetFindingV2_RequestSyntax) **   <a name="accessanalyzer-GetFindingV2-request-uri-analyzerArn"></a>
The [ARN of the analyzer](https://docs.aws.amazon.com/IAM/latest/UserGuide/access-analyzer-getting-started.html#permission-resources) that generated the finding.  
Pattern: `[^:]*:[^:]*:[^:]*:[^:]*:[^:]*:analyzer/.{1,255}`   
Required: Yes

 ** [id](#API_GetFindingV2_RequestSyntax) **   <a name="accessanalyzer-GetFindingV2-request-uri-id"></a>
The ID of the finding to retrieve.  
Required: Yes

 ** [maxResults](#API_GetFindingV2_RequestSyntax) **   <a name="accessanalyzer-GetFindingV2-request-uri-maxResults"></a>
The maximum number of results to return in the response.

 ** [nextToken](#API_GetFindingV2_RequestSyntax) **   <a name="accessanalyzer-GetFindingV2-request-uri-nextToken"></a>
A token used for pagination of results returned.

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "analyzedAt": "string",
   "createdAt": "string",
   "error": "string",
   "findingDetails": [ 
      { ... }
   ],
   "findingType": "string",
   "id": "string",
   "nextToken": "string",
   "resource": "string",
   "resourceOwnerAccount": "string",
   "resourceType": "string",
   "status": "string",
   "updatedAt": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [analyzedAt](#API_GetFindingV2_ResponseSyntax) **   <a name="accessanalyzer-GetFindingV2-response-analyzedAt"></a>
The time at which the resource-based policy or IAM entity that generated the finding was analyzed.  
Type: Timestamp

 ** [createdAt](#API_GetFindingV2_ResponseSyntax) **   <a name="accessanalyzer-GetFindingV2-response-createdAt"></a>
The time at which the finding was created.  
Type: Timestamp

 ** [error](#API_GetFindingV2_ResponseSyntax) **   <a name="accessanalyzer-GetFindingV2-response-error"></a>
An error.  
Type: String

 ** [findingDetails](#API_GetFindingV2_ResponseSyntax) **   <a name="accessanalyzer-GetFindingV2-response-findingDetails"></a>
A localized message that explains the finding and provides guidance on how to address it.  
Type: Array of [FindingDetails](API_FindingDetails.md) objects

 ** [findingType](#API_GetFindingV2_ResponseSyntax) **   <a name="accessanalyzer-GetFindingV2-response-findingType"></a>
The type of the finding. For external access analyzers, the type is `ExternalAccess`. For unused access analyzers, the type can be `UnusedIAMRole`, `UnusedIAMUserAccessKey`, `UnusedIAMUserPassword`, or `UnusedPermission`. For internal access analyzers, the type is `InternalAccess`.  
Type: String  
Valid Values: `ExternalAccess | UnusedIAMRole | UnusedIAMUserAccessKey | UnusedIAMUserPassword | UnusedPermission | InternalAccess` 

 ** [id](#API_GetFindingV2_ResponseSyntax) **   <a name="accessanalyzer-GetFindingV2-response-id"></a>
The ID of the finding to retrieve.  
Type: String

 ** [nextToken](#API_GetFindingV2_ResponseSyntax) **   <a name="accessanalyzer-GetFindingV2-response-nextToken"></a>
A token used for pagination of results returned.  
Type: String

 ** [resource](#API_GetFindingV2_ResponseSyntax) **   <a name="accessanalyzer-GetFindingV2-response-resource"></a>
The resource that generated the finding.  
Type: String

 ** [resourceOwnerAccount](#API_GetFindingV2_ResponseSyntax) **   <a name="accessanalyzer-GetFindingV2-response-resourceOwnerAccount"></a>
Tye AWS account ID that owns the resource.  
Type: String

 ** [resourceType](#API_GetFindingV2_ResponseSyntax) **   <a name="accessanalyzer-GetFindingV2-response-resourceType"></a>
The type of the resource identified in the finding.  
Type: String  
Valid Values: `AWS::S3::Bucket | AWS::IAM::Role | AWS::SQS::Queue | AWS::Lambda::Function | AWS::Lambda::LayerVersion | AWS::KMS::Key | AWS::SecretsManager::Secret | AWS::EFS::FileSystem | AWS::EC2::Snapshot | AWS::ECR::Repository | AWS::RDS::DBSnapshot | AWS::RDS::DBClusterSnapshot | AWS::SNS::Topic | AWS::S3Express::DirectoryBucket | AWS::DynamoDB::Table | AWS::DynamoDB::Stream | AWS::IAM::User` 

 ** [status](#API_GetFindingV2_ResponseSyntax) **   <a name="accessanalyzer-GetFindingV2-response-status"></a>
The status of the finding.  
Type: String  
Valid Values: `ACTIVE | ARCHIVED | RESOLVED` 

 ** [updatedAt](#API_GetFindingV2_ResponseSyntax) **   <a name="accessanalyzer-GetFindingV2-response-updatedAt"></a>
The time at which the finding was updated.  
Type: Timestamp

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.  
HTTP Status Code: 403

 ** InternalServerException **   
Internal server error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource could not be found.    
 ** resourceId **   
The ID of the resource.  
 ** resourceType **   
The type of the resource.
HTTP Status Code: 404

 ** ThrottlingException **   
Throttling limit exceeded error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 429

 ** ValidationException **   
Validation exception error.    
 ** fieldList **   
A list of fields that didn't validate.  
 ** reason **   
The reason for the exception.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/accessanalyzer-2019-11-01/GetFindingV2) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/accessanalyzer-2019-11-01/GetFindingV2) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/accessanalyzer-2019-11-01/GetFindingV2) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/accessanalyzer-2019-11-01/GetFindingV2) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/accessanalyzer-2019-11-01/GetFindingV2) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/accessanalyzer-2019-11-01/GetFindingV2) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/accessanalyzer-2019-11-01/GetFindingV2) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/accessanalyzer-2019-11-01/GetFindingV2) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/accessanalyzer-2019-11-01/GetFindingV2) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/accessanalyzer-2019-11-01/GetFindingV2) 

# GetGeneratedPolicy


Retrieves the policy that was generated using `StartPolicyGeneration`. 

## Request Syntax


```
GET /policy/generation/jobId?includeResourcePlaceholders=includeResourcePlaceholders&includeServiceLevelTemplate=includeServiceLevelTemplate HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [includeResourcePlaceholders](#API_GetGeneratedPolicy_RequestSyntax) **   <a name="accessanalyzer-GetGeneratedPolicy-request-uri-includeResourcePlaceholders"></a>
The level of detail that you want to generate. You can specify whether to generate policies with placeholders for resource ARNs for actions that support resource level granularity in policies.  
For example, in the resource section of a policy, you can receive a placeholder such as `"Resource":"arn:aws:s3:::${BucketName}"` instead of `"*"`.

 ** [includeServiceLevelTemplate](#API_GetGeneratedPolicy_RequestSyntax) **   <a name="accessanalyzer-GetGeneratedPolicy-request-uri-includeServiceLevelTemplate"></a>
The level of detail that you want to generate. You can specify whether to generate service-level policies.   
IAM Access Analyzer uses `iam:servicelastaccessed` to identify services that have been used recently to create this service-level template.

 ** [jobId](#API_GetGeneratedPolicy_RequestSyntax) **   <a name="accessanalyzer-GetGeneratedPolicy-request-uri-jobId"></a>
The `JobId` that is returned by the `StartPolicyGeneration` operation. The `JobId` can be used with `GetGeneratedPolicy` to retrieve the generated policies or used with `CancelPolicyGeneration` to cancel the policy generation request.  
Required: Yes

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "generatedPolicyResult": { 
      "generatedPolicies": [ 
         { 
            "policy": "string"
         }
      ],
      "properties": { 
         "cloudTrailProperties": { 
            "endTime": "string",
            "startTime": "string",
            "trailProperties": [ 
               { 
                  "allRegions": boolean,
                  "cloudTrailArn": "string",
                  "regions": [ "string" ]
               }
            ]
         },
         "isComplete": boolean,
         "principalArn": "string"
      }
   },
   "jobDetails": { 
      "completedOn": "string",
      "jobError": { 
         "code": "string",
         "message": "string"
      },
      "jobId": "string",
      "startedOn": "string",
      "status": "string"
   }
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [generatedPolicyResult](#API_GetGeneratedPolicy_ResponseSyntax) **   <a name="accessanalyzer-GetGeneratedPolicy-response-generatedPolicyResult"></a>
A `GeneratedPolicyResult` object that contains the generated policies and associated details.  
Type: [GeneratedPolicyResult](API_GeneratedPolicyResult.md) object

 ** [jobDetails](#API_GetGeneratedPolicy_ResponseSyntax) **   <a name="accessanalyzer-GetGeneratedPolicy-response-jobDetails"></a>
A `GeneratedPolicyDetails` object that contains details about the generated policy.  
Type: [JobDetails](API_JobDetails.md) object

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.  
HTTP Status Code: 403

 ** InternalServerException **   
Internal server error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 500

 ** ThrottlingException **   
Throttling limit exceeded error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 429

 ** ValidationException **   
Validation exception error.    
 ** fieldList **   
A list of fields that didn't validate.  
 ** reason **   
The reason for the exception.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/accessanalyzer-2019-11-01/GetGeneratedPolicy) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/accessanalyzer-2019-11-01/GetGeneratedPolicy) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/accessanalyzer-2019-11-01/GetGeneratedPolicy) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/accessanalyzer-2019-11-01/GetGeneratedPolicy) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/accessanalyzer-2019-11-01/GetGeneratedPolicy) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/accessanalyzer-2019-11-01/GetGeneratedPolicy) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/accessanalyzer-2019-11-01/GetGeneratedPolicy) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/accessanalyzer-2019-11-01/GetGeneratedPolicy) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/accessanalyzer-2019-11-01/GetGeneratedPolicy) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/accessanalyzer-2019-11-01/GetGeneratedPolicy) 

# ListAccessPreviewFindings


Retrieves a list of access preview findings generated by the specified access preview.

## Request Syntax


```
POST /access-preview/accessPreviewId HTTP/1.1
Content-type: application/json

{
   "analyzerArn": "string",
   "filter": { 
      "string" : { 
         "contains": [ "string" ],
         "eq": [ "string" ],
         "exists": boolean,
         "neq": [ "string" ]
      }
   },
   "maxResults": number,
   "nextToken": "string"
}
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [accessPreviewId](#API_ListAccessPreviewFindings_RequestSyntax) **   <a name="accessanalyzer-ListAccessPreviewFindings-request-uri-accessPreviewId"></a>
The unique ID for the access preview.  
Pattern: `[a-f0-9]{8}-[a-f0-9]{4}-[a-f0-9]{4}-[a-f0-9]{4}-[a-f0-9]{12}`   
Required: Yes

## Request Body


The request accepts the following data in JSON format.

 ** [analyzerArn](#API_ListAccessPreviewFindings_RequestSyntax) **   <a name="accessanalyzer-ListAccessPreviewFindings-request-analyzerArn"></a>
The [ARN of the analyzer](https://docs.aws.amazon.com/IAM/latest/UserGuide/access-analyzer-getting-started.html#permission-resources) used to generate the access.  
Type: String  
Pattern: `[^:]*:[^:]*:[^:]*:[^:]*:[^:]*:analyzer/.{1,255}`   
Required: Yes

 ** [filter](#API_ListAccessPreviewFindings_RequestSyntax) **   <a name="accessanalyzer-ListAccessPreviewFindings-request-filter"></a>
Criteria to filter the returned findings.  
Type: String to [Criterion](API_Criterion.md) object map  
Required: No

 ** [maxResults](#API_ListAccessPreviewFindings_RequestSyntax) **   <a name="accessanalyzer-ListAccessPreviewFindings-request-maxResults"></a>
The maximum number of results to return in the response.  
Type: Integer  
Required: No

 ** [nextToken](#API_ListAccessPreviewFindings_RequestSyntax) **   <a name="accessanalyzer-ListAccessPreviewFindings-request-nextToken"></a>
A token used for pagination of results returned.  
Type: String  
Required: No

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "findings": [ 
      { 
         "action": [ "string" ],
         "changeType": "string",
         "condition": { 
            "string" : "string" 
         },
         "createdAt": "string",
         "error": "string",
         "existingFindingId": "string",
[...]
